#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "config.h"
#include "getarg.h"
#include "file.h"

typedef struct {
    char *name;
    char *arg;
    char *description;
    int(*func)(char *);
} option_t;

option_t options[] = {
    {"help", NULL, "ץɽ", opt_help},
    {"savedir", "dir", "֥ǥ쥯ȥ", opt_savedir},
};
#define OPTION_NUM (sizeof(options) / sizeof(option_t))

static char *argv0;
static char *save_dir = NULL;

int getarg(int argc, char *argv[], char *save_dirname){
    int i, j;

    argv0 = argv[0];
    for (i = 1 ; i < argc ; i++){
        switch (argv[i][0]){
        case '-':
            switch(argv[i][1]){
            case '-':
                for (j = 0 ; j < OPTION_NUM ; j++){
                    //                    printf(":%s:%s:\n", &argv[i][2], options[j].name);
                    if (strcmp(&argv[i][2], options[j].name) == 0){
                        if (options[j].arg){
                            if (i+1 < argc){
                                i++;
                                if (options[j].func(argv[i])) return -1;
                            }
                            else { // եץΰʤ
                                opt_help(NULL);
                                return -1;
                            }
                        }
                        else {
                            if (options[j].func(NULL)) return -1;
                        }
                        break;
                    }
                }
                //                printf("%d %d\n", j, OPTION_NUM);
                if (j == OPTION_NUM){
                    opt_help(NULL);
                    return -1;
                }
                break;
            default:
                break;
            }
            break;
        default:
            // СǤϥץʳΰϥݡȤʤ
            break;
        }
    }
    // !!! ֥ѥѥλꥪץä顢ʲϽ
    set_save_dpath(argv0, save_dir, save_dirname);
    set_log_fpath(LOG_FILE);
    return 0;
}

int opt_help(char *arg){
    int i;

    assert(arg == NULL);

    fprintf(stderr, "Ȥ: %s [options]\n", argv0);
    for (i = 0 ; i < OPTION_NUM ; i++){
        printf("  --%-10s %-4s : %s\n", 
               options[i].name, 
               options[i].arg ? options[i].arg : "",
               options[i].description);
    }
    return -1;
}

int opt_savedir(char *arg){
    //    printf("specify savedir:%s\n", arg);
    save_dir = arg;
    return 0;
}
