#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "param.h"
#include "layout.h"
#include "howtoplay.h"
#include "howtoplay_draw.h"
#include "font.h"
#include "obj_draw.h"
#include "draw.h"
#include "uty.h"

static char *title_str = "ӡ";
static font_id_t *title_fontseq;
int title_x;

static char *menu_strs[] = {
	"롼",
	"ۤۤ",
	"Ȥ礦ʡˤ֤",
	"",
};
#define MENU_NUM (sizeof(menu_strs)/sizeof(char*))
static font_id_t **menu_fontseqs;
static int menu_x[MENU_NUM];



static char *rule_strs[] = {
	"򡡤ơǤΤߤ򡡤٤Ƥ",
	"֤ΤޡפΡ٤ȡǤҤ餭ޤ",
	"ǤˡϤȡơꤢǤ",
	"Τꤸȡ٤ǤΤߤȤƤˡʤޤ",
	"ޤ֤⤯Ҥ礦פΡ礦򡡤ߤȡ"
	"ȤƤ󤬡դޤ",
	"",
	"Ҥ",
	"ˡΤ礯ϡޤ",
	"Ƥϡ褱뤫ۤΤƤ䡡򡡤ĤäơƤ",
	"󤬡0ˤʤäƤ⡡पСˤϡʤޤ",
//	"󤻤ϡޤ",
	"ޤϡ٤ƤƤȤϡޤ",
	"ΤʤΤ䡡褦ǤΤ⡡ޤ",
//	"ΤʤΤ䡡礦礦ˤꡡˤʤΤ⡡ޤ",
	"ä⤯Ҥ礦ϡơ󤿤ǡҤ礦ޤ",
	"ɤˡ٤ơäǤȤϡޤ",
	"⤯Ҥ礦ˡ碌ơ㤯ۤۤ򡡤ƤߤƤ",
};
#define RULE_NUM (sizeof(rule_strs)/sizeof(char*))
static font_id_t **rule_fontseqs;


key_info_t key_infos[] = {
	{"", "", "ˤ塼", NULL, NULL, NULL},
	{"", "Ҥˤɤ", "뤤ɤ", NULL, NULL, NULL},
	{"", "ߤˤɤ", "뤤ɤ", NULL, NULL, NULL},
	{"", "", "뤤ɤ", NULL, NULL, NULL},
	{"", NULL, "뤤ɤ", NULL, NULL, NULL},
	{"", "", "äƤ", NULL, NULL, NULL},
	{"", NULL, "äƤ", NULL, NULL, NULL},
	{"P", "Ƥ", NULL, NULL, NULL, NULL},
	{"æ", "Ƥ", "ɤ", NULL, NULL, NULL},
	{"G", "ʤ", NULL, NULL, NULL, NULL},
	{"Q", "夦礦", "ɤ", NULL, NULL, NULL},
};
#define KEY_INFO_NUM (sizeof(key_infos)/sizeof(key_info_t))

character_info_t character_infos[] = {
    {"", "Ǥ󤬤", CHEE_SIZE, {ii_chee_wl0, ii_chee_wl1}, 2, 0, 0, NULL, NULL},
    {"ǤΤ", "", GONDIN_SIZE, {ii_gondin, ii_gondin}, 1, 0, 0, NULL, NULL},
    {"ϤȤ", "ब", HATOPO_SIZE, {ii_hatopo_wl0, ii_hatopo_wl1}, 2, 0, 0, NULL, NULL},
    {"ޤ", "Ȥ", YAARASHI_HEIGHT, {ii_yaarashi_wl0, ii_yaarashi_wl1}, 2, 0, 0, NULL, NULL},
//    {"䤢餷", "Ȥ", YAARASHI_HEIGHT, {ii_yaarashi_wl0, ii_yaarashi_wl1}, 2, 0, 0, NULL, NULL},
    {"ä", "Ĥäߤ夦", GAGGA_SIZE, {ii_gagga_n0, ii_gagga_n0}, 2, 0, 0, NULL, NULL},
    {"ꤽ", "ĤϤڤ", OJIGIRI_HEIGHT, {ii_ojigiri_l, ii_ojigiri_r}, 8, 0, 0, NULL, NULL},
    {"ˤ㤢Ѥ", "ǤΤӡ", NYA_HEIGHT, {ii_nya_l, ii_nya_l}, 2, 0, 0, NULL, NULL},
    {"", "ҤϤ", SUE_HEIGHT, {ii_sue_hcl, ii_sue_hol}, 16, 0, 0, NULL, NULL},
    //    {"", "", {ii_, ii_}, NULL, NULL},
};

#define CHARACTER_INFO_NUM (sizeof(character_infos)/sizeof(character_info_t))

terran_info_t terran_infos[] = {
    {"", "ʤ", GRID_SIZE, ii_wall, NULL, NULL, NULL},
    {"", "Ȥ", GRID_SIZE, ii_fwall, NULL, NULL, NULL},
    {"Τ", "ۤΤǤȤ", GRID_SIZE, ii_iwall, NULL, NULL, NULL},
    {"Фꤢ", "Ȥʤ", GRID_SIZE, ii_barrier0, NULL, NULL, NULL},
    {"", "뤤ƤΤܤ", GRID_SIZE, ii_stairs_l, NULL, NULL, NULL},
    {"", "ĤĤ뤹٤", GRID_SIZE, ii_slope_l, NULL, NULL, NULL},
    {"ää", "դȤɤ", GRID_SIZE, ii_mswitch_off, NULL, NULL, NULL},
    {"Ȥ뤹ä", "դȤ꤫", GRID_SIZE, ii_aswitch_off, NULL, NULL, NULL},
    {"Ȥ", "Ȥ", GRID_SIZE, ii_sting_u, NULL, NULL, NULL},
    {"Ƥդ", "ʤˤƤ", SIGN_HEIGHT, ii_sign, NULL, NULL, NULL},
    {"դ", "ΤäƤɤ", GRID_SIZE, ii_none, draw_terran_lift, NULL, NULL},
    {"Ǥ", "ϤȤꤢ", GOAL_HEIGHT, ii_goal_closed, NULL, NULL, NULL},
};

#define TERRAN_INFO_NUM (sizeof(terran_infos)/sizeof(terran_info_t))




void howtoplay_draw_init(void){
    int i;
    title_fontseq = alloc_fontseq(title_str);
	title_x = FontSeqCenterLx(title_fontseq);
	menu_fontseqs = alloc_fontseq_array(MENU_NUM);
	for (i = 0 ; i < MENU_NUM ; i++){
		menu_fontseqs[i] = alloc_fontseq(menu_strs[i]);
		if (i == 0){
			menu_x[i] = 40;
		}
		else {
			menu_x[i] = menu_x[i-1]+FontSeqWidth(menu_fontseqs[i-1])+32;
		}
	}
	rule_fontseqs = alloc_fontseq_array(RULE_NUM);
	for (i = 0 ; i < RULE_NUM ; i++){
		rule_fontseqs[i] = alloc_fontseq(rule_strs[i]);
    }
	for (i = 0 ; i < KEY_INFO_NUM ; i++){
	    key_infos[i].key_fontseq
		    = alloc_fontseq(key_infos[i].key_str);
		if (key_infos[i].description_game_str != NULL){
			key_infos[i].description_game_fontseq 
				= alloc_fontseq(key_infos[i].description_game_str);
		}
		if (key_infos[i].description_menu_str != NULL){
			key_infos[i].description_menu_fontseq 
				= alloc_fontseq(key_infos[i].description_menu_str);
		}
	}
	for (i = 0 ; i < CHARACTER_INFO_NUM ; i++){
        character_infos[i].name_fontseq
            = alloc_fontseq(character_infos[i].name_str);
        character_infos[i].description_fontseq 
            = alloc_fontseq(character_infos[i].description_str);
	}
	for (i = 0 ; i < TERRAN_INFO_NUM ; i++){
        terran_infos[i].name_fontseq
            = alloc_fontseq(terran_infos[i].name_str);
        terran_infos[i].description_fontseq 
            = alloc_fontseq(terran_infos[i].description_str);
	}
}

void draw_howtoplay(void){
    int i;
	howtoplay_menuitem_t mode;

	mode = howtoplay_mode();
    draw_fontseq(title_x, 8, title_fontseq);

	for (i = 0 ; i < MENU_NUM ; i++){
        draw_fontseq(menu_x[i], 8+LINESKIP+8, menu_fontseqs[i]);
	}
//    draw_img(ii_punch_r,
    draw_img(ii_chee16_wr0,
			 RDX(menu_x[mode]-20), RDY(8+LINESKIP+8));

	switch(mode){
	case hi_rule:
		draw_rule();
		break;
	case hi_keys:
		draw_keys();
		break;
	case hi_character:
		draw_characters();
		break;
	case hi_terran:
		draw_terrans();
		break;
	default:
		break;
	}
	EzShowBuffer();    
}
void draw_rule(void){
	int i;
	for (i = 0 ; i < RULE_NUM ; i++){
        draw_fontseq(32, HOWTOPLAY_VIEW_LTY+i*LINESKIP, rule_fontseqs[i]);
    }
}
void draw_keys(void){
	int i;
	for (i = 0 ; i < KEY_INFO_NUM ; i++){
        draw_fontseq(128,    HOWTOPLAY_VIEW_LTY+i*LINESKIP*3/2, key_infos[i].key_fontseq);
        if (key_infos[i].description_game_fontseq != NULL){
			draw_fontseq(128+48, HOWTOPLAY_VIEW_LTY+i*LINESKIP*3/2, key_infos[i].description_game_fontseq);
		}
        if (key_infos[i].description_menu_fontseq != NULL){
	        draw_fontseq(128+48+128, HOWTOPLAY_VIEW_LTY+i*LINESKIP*3/2, key_infos[i].description_menu_fontseq);
		}
    }
}

void draw_characters(void){
	int i, x, y;
	
	x = HOWTOPLAY_VIEW_LTX;
	y = HOWTOPLAY_VIEW_LTY;
	for (i = 0 ; i < CHARACTER_INFO_NUM ; i++){
        draw_fontseq(x+48+16, y, character_infos[i].name_fontseq);
        draw_fontseq(x+48+16, y+LINESKIP, character_infos[i].description_fontseq);
        character_infos[i].motion_count ++;
        if (character_infos[i].motion_count == character_infos[i].motion_interval){
            character_infos[i].motion = character_infos[i].motion ? 0 : 1;
            character_infos[i].motion_count = 0;
        }
        draw_img(character_infos[i].img[character_infos[i].motion],
                 RDX(x),
                 RDY(y));
		y += MaxInt(LINESKIP*3, DScale(character_infos[i].height)+16);
		if (y > 400){
			x +=240;
			y = HOWTOPLAY_VIEW_LTY;
		}
    }
}

void draw_terrans(void){
	int i, x, y;
	
	x = HOWTOPLAY_VIEW_LTX;
	y = HOWTOPLAY_VIEW_LTY;
	for (i = 0 ; i < TERRAN_INFO_NUM ; i++){
        draw_fontseq(x+48+16, y, terran_infos[i].name_fontseq);
        draw_fontseq(x+48+16, y+LINESKIP, terran_infos[i].description_fontseq);
		if (terran_infos[i].img != ii_none){
	        draw_img(terran_infos[i].img,
		             RDX(x),
			         RDY(y));
		}
		if (terran_infos[i].draw_func){
	        terran_infos[i].draw_func(RDX(x), RDY(y));
		}
		y += MaxInt(LINESKIP*3, DScale(terran_infos[i].height)+16);
		if (y > 400){
			x +=240;
			y = HOWTOPLAY_VIEW_LTY;
		}
    }
}


void draw_terran_lift(int x, int y){
	obj_t obj;
	obj.x = x;
	obj.y = y;
	obj.width = GRID_SIZE*2;
	obj.height = GRID_SIZE;
	draw_lift(&obj);
}
