#ifndef OBJ_DRAW_H
#define OBJ_DRAW_H

#include "obj.h"

typedef enum {
    ii_begin = 0,
    ii_none,
    ii_wall,
	ii_sign,
	ii_goal_closed,
	ii_goal_open1,
	ii_goal_open2,
	ii_goal_opened,
	ii_goal_exl1,
//	ii_goal_exr1,
//	ii_goal_exl2,
	ii_goal_exr2,
	ii_goal_exl3,
//	ii_goal_exr3,
    ii_stairs_l,
    ii_stairs_r,
    ii_slope_l,
    ii_slope_r,
    ii_sting_l,
    ii_sting_r,
    ii_sting_u,
    ii_sting_d,
	ii_mswitch_off,
	ii_mswitch_on,
	ii_aswitch_off,
	ii_aswitch_on,

    ii_fwall,
	ii_iwall,
	ii_barrier0,
	ii_barrier1,
	ii_barrier2,
	ii_barrier3,
    ii_gondin,
    ii_gondin_sv1,
    ii_gondin_sv2,
    ii_gondin_sh1,
    ii_gondin_sh2,
    ii_gondin_bn,
	ii_chee16_wr0,
    ii_chee_init,
    ii_chee_back,
    ii_chee_exit_l1,
    ii_chee_exit_l2,
    ii_chee_exit_l3,
    ii_chee_exit_r1,
    ii_chee_exit_r2,
    ii_chee_exit_r3,
	ii_chee_e0,
    ii_chee_e1,
    ii_chee_e2,
    ii_chee_e7,
    ii_chee_e8,
    ii_chee_e9,
	ii_chee_es0,
    ii_chee_es1,
    ii_chee_es2,
    ii_chee_es7,
    ii_chee_es8,
    ii_chee_es9,
    ii_chee_wl0,
    ii_chee_wl1,
    ii_chee_wr0,
    ii_chee_wr1,
    ii_chee_jl,
    ii_chee_jr,
    ii_chee_fl,
    ii_chee_fr,
    ii_chee_svl1,
    ii_chee_svl2,
    ii_chee_svr1,
    ii_chee_svr2,
    ii_chee_shl1,
    ii_chee_shl2,
    ii_chee_shr1,
    ii_chee_shr2,
	ii_chee_bl,
	ii_chee_br,
	ii_chee_pl,
	ii_chee_pr,
    ii_chee_gl0,
    ii_chee_gr0,
    ii_chee_bnl,
    ii_chee_bnr,

    ii_hatopo_wl0,
    ii_hatopo_wl1,
    ii_hatopo_wr0,
    ii_hatopo_wr1,
    ii_hatopo_sl,
    ii_hatopo_sr,
    ii_hatopo_shl1,
    ii_hatopo_shl2,
    ii_hatopo_shr1,
    ii_hatopo_shr2,
    ii_hatopo_svl1,
    ii_hatopo_svl2,
    ii_hatopo_svr1,
    ii_hatopo_svr2,
	ii_hatopo_bl,
	ii_hatopo_br,
	ii_hatopo_pl,
	ii_hatopo_pr,
	ii_hatopo_bnl,
	ii_hatopo_bnr,

	ii_gagga_n0,
	ii_gagga_al0,
	ii_gagga_al1,
	ii_gagga_ar0,
	ii_gagga_ar1,
	ii_gagga_p,
	ii_gagga_bn,
	ii_nya_l,
	ii_nya_r,
	ii_punch_l,
	ii_punch_r,
	ii_yaarashi_wl0,
	ii_yaarashi_wl1,
	ii_yaarashi_wr0,
	ii_yaarashi_wr1,
	ii_yaarashi_pl,
	ii_yaarashi_pr,
	ii_yaarashi_bnl,
	ii_yaarashi_bnr,
	ii_ojigiri_l,
	ii_ojigiri_r,
	ii_ojigiri_el2,
	ii_ojigiri_el3,
	ii_ojigiri_el4,
	ii_ojigiri_er2,
	ii_ojigiri_er3,
	ii_ojigiri_er4,
	ii_ojigiri_d0,
	ii_ojigiri_d1,
    ii_ojigiri_shl1,
    ii_ojigiri_shl2,
    ii_ojigiri_shr1,
    ii_ojigiri_shr2,
    ii_ojigiri_svl1,
    ii_ojigiri_svl2,
    ii_ojigiri_svr1,
    ii_ojigiri_svr2,
    ii_ojigiri_bnl,
    ii_ojigiri_bnr,
	ii_sue_hcl,
	ii_sue_hol,
	ii_sue_lcl,
	ii_sue_lol,
	ii_sue_hcr,
	ii_sue_hor,
	ii_sue_lcr,
	ii_sue_lor,
	ii_sue_pl,
	ii_sue_pr,
	ii_sue_bnl,
	ii_sue_bnr,
	ii_flame_ml,
	ii_flame_mr,

    ii_bang4_4,
    ii_bang8_4,
    ii_bang8_8,
    ii_bang8_16,
    ii_bang12_8,

    ii_bone,

    ii_end
} image_id_t;

typedef struct {
	image_id_t iid;
	int xoffset, yoffset;
} motion_image_t;

typedef struct {
    image_id_t iid;
    char **xpm;
} xpm_info_t;
    
typedef struct {
    obj_type_t type;
    image_id_t iid;
} type2iid_info_t;

typedef struct {
	image_id_t smash_h1_l, smash_h1_r;
	image_id_t smash_h2_l, smash_h2_r;
	image_id_t smash_v1_l, smash_v1_r;
	image_id_t smash_v2_l, smash_v2_r;
	image_id_t pierced_l, pierced_r;
	image_id_t burned_l, burned_r;
	image_id_t bang;
} creature_images_t;

typedef struct {
	obj_type_t type;
	creature_images_t images;
} creature_image_info_t;


void obj_draw_init(void);

void draw_img(image_id_t iid, int x, int y);
int draw_static(obj_t *obj);
int draw_motion(obj_t *obj);
int draw_fwall(obj_t *obj);
int draw_iwall(obj_t *obj);
int draw_goal(obj_t *obj);
int draw_chee(obj_t *obj);
int post_draw_ojigiri(obj_t *obj);
int draw_gagga(obj_t *obj);
int post_draw_gagga(obj_t *obj);
int draw_nya(obj_t *obj);
int draw_punch(obj_t *obj);
int draw_block(obj_t *obj);
int draw_sting(obj_t *obj);
int draw_lift(obj_t *obj);
int draw_switch(obj_t *obj);
int draw_barrier(obj_t *obj);

void draw_hitmarker(void);

#endif
