#include <stdio.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "param.h"
#include "objective.h"
#include "font.h"

static objective_info_t objective_infos[] = {
	{NULL, id_dec, "time",     "Τꤸ",       NULL, re_time},
    {NULL, id_inc, "gondin",   "٤Ǥ",   NULL, re_gondin_eaten},
    {NULL, id_inc, "walk",     "뤤ۤ",     NULL, re_walk_frame},
    {NULL, id_inc, "jump",     "פ",   NULL, re_jump_count},
    {NULL, id_inc, "lift",     "դȤˤΤä",     NULL, re_lift_frame},
    {NULL, id_inc, "hatopo",   "ϤȤ",       NULL, re_hatopo_killed},
    {NULL, id_inc, "gagga",    "ä",       NULL, re_gagga_killed},
    {NULL, id_inc, "yaarashi", "ޤ",     NULL, re_yaarashi_killed},
    {NULL, id_inc, "blast",    "Ĥäߤ",   NULL, re_blast_count},
    {NULL, id_inc, "fwall",    "줿",       NULL, re_fwall_destroyed},
    {NULL, id_inc, "iwall",    "Ȥ",       NULL, re_iwall_destroyed},
};
#define OBJECTIVE_INFO_NUM (sizeof(objective_infos)/sizeof(objective_info_t))

void objective_init(void){
    int i;

    for (i = 0 ; i < OBJECTIVE_INFO_NUM ; i++){
        objective_infos[i].icon = get_record_icon(objective_infos[i].entry);
        objective_infos[i].description_fontseq
			= alloc_fontseq(objective_infos[i].description);
    }
}

int objective_name2id(char *name){
    int i;

    for (i = 0 ; i < OBJECTIVE_INFO_NUM ; i++){
        if (strcmp(name, objective_infos[i].name) == 0) return i;
    }
    return -1;
}

objective_info_t *get_objective_info(int id){
    return &objective_infos[id];
}


#ifdef DUMMY

record_entry_t objective_id2entry(int id){
	return objective_infos[id].entry;
}
#endif


