#ifndef OBJECTIVE_H
#define OBJECTIVE_H
#include "config.h"
#include "record.h"
#include "font.h"

typedef enum {
    oo_none, oo_le, oo_ge, oo_eq
} objective_operator_t;

typedef enum {
    id_inc, id_dec
} incdec_type_t;

typedef struct {
    font_id_t *icon;
    incdec_type_t incdec;
    char *name;
	char *description;
	font_id_t *description_fontseq;
    record_entry_t entry;
} objective_info_t;

typedef struct {
    record_entry_t entry;
    incdec_type_t incdec;    
    objective_operator_t op;
    unsigned int val;
	font_id_t *icon;
	font_id_t *description_fontseq;
} objective_t;

void objective_init(void);
int objective_name2id(char *name);
objective_info_t *get_objective_info(int id);
#endif
