#include <stdio.h>
#include <EzGraph.h>

#include "config.h"
#include "layout.h"
#include "title.h"
#include "title_draw.h"
#include "font.h"
#include "obj_draw.h"

#include "xpm/title.xpm"

static EzImage title_img;

static char *title_str = "󡡤ǡ";
static font_id_t *title_fontseq;

static char *item_strs[ti_end] = {
	"",
	"Ĥᤤ",
//	"Ǥ",
//	"äƤ",
	"",
};

#define ITEM_NUM (sizeof(item_strs)/sizeof(char*))
static font_id_t **item_fontseqs;

/*
static char *test_strs[ti_end] = {
	"夲स夲ऴΤ꤭",
	"礦夦ᤤΤ礦",
	"ơȤФꤿ뤹ꤢФ롡ͤȤ꡼",
	"Ҥ㤯ޤ󤫤ͤ",
};
static font_id_t** test_fontseqs;
*/

void title_draw_init(void){
	int i;

    assert(ti_end == ITEM_NUM);

    title_img = EzReadXPM(title_xpm);
    title_fontseq = alloc_fontseq(title_str);
    item_fontseqs = alloc_fontseq_array(ITEM_NUM);
	for (i = 0 ; i < ITEM_NUM ; i++){
		item_fontseqs[i] = alloc_fontseq(item_strs[i]);
	}



    /*
    test_fontseqs = alloc_fontseq_array(ITEM_NUM);
	for (i = 0 ; i < ITEM_NUM ; i++){
		test_fontseqs[i] = alloc_fontseq(test_strs[i]);
	}
    */
}

void draw_title(void){
	int i;

    EzPutB((WIN_WIDTH-397)/2, 24, title_img);
    draw_fontseq((WIN_WIDTH-16*9)/2, 192, title_fontseq);
	for (i = 0 ; i < ITEM_NUM ; i++){
        draw_fontseq((WIN_WIDTH-16*4)/2, 320+i*LINESKIP, item_fontseqs[i]);
	}
//    draw_img(ii_punch_r,
    draw_img(ii_chee16_wr0,
             (WIN_WIDTH-16*4)/2/GRID_SIZE-6,
             320/GRID_SIZE+get_title_cursor_pos()*LINESKIP/GRID_SIZE);

	EzShowBuffer();
    /*
    str2fontseq(str_title, msg);
    draw_fontseq((SCREEN_WIDTH-16*5)/2, 240, msg);
    str2fontseq(str_test, msg);
    draw_fontseq((SCREEN_WIDTH-16*5)/2, 260, msg);

    for (i = 0 ; i < ITEM_NUM ; i++){
        draw_fontseq((SCREEN_WIDTH-16*5)/2, 400+i*20, test_fontseqs[i]);
    }	
    */
}
